 -- ===============================================================

function love.load()

	-- game 
	game = {} 
	game.width = love.window.getWidth() 
	game.height = love.window.getHeight() 
	game.paddleWidth = 90 
	game.paddleHeight = 20 
	game.paddleSpeed = 10 
	game.timer = nil
	game.timerLimit = nil
	game.timerLimitCycles = nil

	-- ball
	ball = {}
	ball.location = {0,0}
	ball.speed = nil
	ball.direction = 1
	ball.angle = 0
	ball.outOfBoundsFlag = false
	ball.size = 8;

	-- player
	player = {};
	player.x = 0;

	startGame()

end


function startGame() 
	print ('game started')
	game.timer = 0
	game.timerLimit = 5
	game.timerLimitCycles = 0
	ball.speed = 5

	spawnBall()
end

function spawnBall()

	ball.location = { math.random(0, love.window.getWidth()/2),
		math.random(0, love.window.getHeight()/2)
	}
	ball.direction = 1
	ball.angle = math.random(-5,5)
	ball.outOfBoundsFlag = false

end

 -- ===============================================================

function love.draw()

	-- draw paddle
	love.graphics.setColor(255,255,255,255)
	love.graphics.rectangle("fill", player.x, game.height - game.paddleHeight, game.paddleWidth, game.paddleHeight)

	-- draw ball
	love.graphics.circle("fill", ball.location[1], ball.location[2], ball.size, ball.size)	
end 	

 -- ===============================================================

function love.update(dt)

	-- game.timerLimitCycles (to increase the ball speed by 1 every time a Cycle happens)
	game.timer = game.timer + dt
	if game.timer >= game.timerLimit then
		game.timerLimitCycles = game.timerLimitCycles + 1
		game.timer = 0
		ball.speed = ball.speed + 1
	  print (game.timerLimitCycles)
	end

	-- keyboard input
	if love.keyboard.isDown("left") then
		player.x = player.x - game.paddleSpeed
		if player.x < 0 then player.x = 0 end
	elseif love.keyboard.isDown("right") then
		player.x = player.x + game.paddleSpeed
		if (player.x > love.window.getWidth() - game.paddleWidth) then 
			player.x = love.window.getWidth() - game.paddleWidth 
		end
	end

	-- ball X motion
	ball.location[1] = ball.location[1] + ball.angle

	if ball.location[1] < ball.size then
		ball.angle = ball.angle * -1	
	elseif ball.location[1] > love.window.getWidth() - ball.size then
		ball.angle = ball.angle * -1
	end

	-- ball Y motion
	if ball.direction == -1 then
		ball.location[2] = ball.location[2] - ball.speed;
	else
		ball.location[2] = ball.location[2] + ball.speed;	
	end

	-- collision detection
	if ball.outOfBoundsFlag == false then
		if ball.location[2] > love.window.getHeight() - game.paddleHeight - ball.size then
			if ball.location[1] > player.x and ball.location[1] < player.x + game.paddleWidth then
				ball.direction = ball.direction * -1
			else 
				ball.outOfBoundsFlag = true
			end	
		elseif ball.location[2] < ball.size then
			ball.direction = ball.direction * -1
		end
	else
			if ball.location[2] > love.window.getHeight() + 10 then
				startGame()	
			end	
	end	

end

